# Detect the distribution in use
%global __despace /usr/bin/head -n 1 | /usr/bin/tr -d '[:space:]' | %{__sed} -e 's/[(].*[)]//g'
%global __lower4 /usr/bin/cut -c 1-4 | /usr/bin/tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(%{__sed} -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(%{__sed} -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS & White Box as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "wbel"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%{!?perl_vendorlib: %global perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)}
%{!?__id_u: %global __id_u %([ -x /bin/id ]&&echo /bin/id||([ -x /usr/bin/id ]&&echo /usr/bin/id||echo /bin/true)) -u}

# TODO: Add these buildreqs when available
#BuildRequires: perl(DateTime::Format::HTTP)
#BuildRequires: perl(DateTime::Format::Mail)
#BuildRequires: perl(DateTime::Format::IBeat)

Name:		perl-DateTime-Format-Builder
Epoch:		1
Version:	0.80
Release:	4.%{__distinit}%{__distvers}
Summary:	Create DateTime parser classes and objects
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/DateTime-Format-Builder/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/DateTime-Format-Builder-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch
BuildRequires:	perl(Module::Build)
BuildRequires:	perl(Class::Factory::Util)
BuildRequires:	perl(DateTime)
BuildRequires:	perl(DateTime::Format::Strptime)
BuildRequires:	perl(Params::Validate) >= 0.73
BuildRequires:	perl(Task::Weaken)
%if %(%{__perl} -e 'print (($^V and $^V ge 5.8.2) ? 1 : 0);')
BuildRequires:	perl(Test::Memory::Cycle)
%endif
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::Signature)
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires:	perl(Class::Factory::Util)
Requires:	perl(DateTime::Format::Strptime)

# Filter out bogus dependencies from the examples (rpm 4.9 onwards)
%global __requires_exclude perl\\(DateTime::Format::(HTTP|IBeat|Mail)\\)

%description
DateTime::Format::Builder creates DateTime parsers. Many string formats of
dates and times are simple and just require a basic regular expression to
extract the relevant information. Builder provides a simple way to do this
without writing reams of structural code.

Builder provides a number of methods, most of which you'll never need, or at
least rarely need. They're provided more for exposing of the module's innards
to any sub-classes, or for when you need to do something slightly beyond what
is expected.

%prep
%setup -q -n DateTime-Format-Builder-%{version}

# Filter out bogus dependencies from the examples (prior to rpm 4.9)
%global reqfilt /bin/sh -c "%{__perl_requires} | %{__grep} -Evx 'perl[(]DateTime::Format::(HTTP|IBeat|Mail)[)]'"
%define __perl_requires %{reqfilt}
# Filter out bogus provide of perl(main) on older distributions
%global provfilt /bin/sh -c "%{__perl_provides} | %{__grep} -Fvx 'perl(main)'"
%define __perl_provides %{provfilt}

# Recode docs as UTF-8
for doc in AUTHORS CREDITS LICENCE README
do
	/usr/bin/iconv -f iso-8859-1 -t utf-8 < ${doc} > ${doc}.utf8
	%{__mv} ${doc}.utf8 ${doc}
done

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} pure_install PERL_INSTALL_ROOT=%{buildroot}
/usr/bin/find %{buildroot} -type f -name .packlist -exec %{__rm} -f {} \;
/usr/bin/find %{buildroot} -depth -type d -exec /bin/rmdir {} \; 2>/dev/null
%{_fixperms} %{buildroot}

%check
LC_ALL=C %{__make} test

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc COPYING Artistic Changes AUTHORS CREDITS LICENCE README examples/
%{perl_vendorlib}/DateTime/
%{_mandir}/man3/DateTime::Format::Builder.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Dispatch.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Quick.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Regex.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::Strptime.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Parser::generic.3pm*
%{_mandir}/man3/DateTime::Format::Builder::Tutorial.3pm*

%changelog
* Fri Mar  4 2011 Paul Howarth <paul@city-fan.org> 1:0.80-4
- BR: perl(Test::Memory::Cycle) where possible for additional test coverage
- Fix dependency filter for rpm 4.9.x
- Filter bogus provides of perl(main) on older distributions

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 1:0.80-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 19 2010 Paul Howarth <paul@city-fan.org> 1:0.80-2
- Fix dist tag for RHEL-6 Beta
- Recode README as UTF-8

* Sun Mar 14 2010 Paul Howarth <paul@city-fan.org> 1:0.80-1
- Update to 0.80 (clean up tests)
- Bump epoch since upstream promises to stick to 2 digits after the decimal
  point from now on
- Signature test dropped, so no need to go to great lengths to pass it now

* Thu Feb  4 2010 Paul Howarth <paul@city-fan.org> 0.7901-6
- Import from Fedora
- Tweak build process to pass signature test

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> 0.7901-5
- Rebuild against perl 5.10.1

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 0.7901-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> 0.7901-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Mar  4 2008 Tom "spot" Callaway <tcallawa@redhat.com> 0.7901-2
- Rebuild for new perl

* Sat Jan 26 2008 Chris Weyl <cweyl@alumni.drew.edu> 0.7901-1
- Update to 0.7901
- Additional docs
- Some spec rework

* Thu Aug 31 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-4
- Bump for mass rebuild

* Tue Aug 08 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-3
- Bump for release & build, not in that order

* Tue Aug 08 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-2
- Additional br's

* Fri Aug 04 2006 Chris Weyl <cweyl@alumni.drew.edu> 0.7807-1
- Initial spec file for F-E
